Subject: Re: [PATCH] iproute2: ip route flush bugfix

From: Eric Dumazet <[email-masked]>
Date: Mon, 09 Nov 2009 21:24:44 +0100

Sven Anders a écrit :
> Hello!
> 
> I experienced an error, if I try to perform a
> 
>   ip route flush proto 4
> 
> with many routes in a complex environment, it
> gave me the following error:
> 
>   Failed to send flush request: Success
>   Flush terminated
> 
> I'm using version 2.6.29.
> I check GIT, but there was only the "MSG_PEEK" fix.
> 
> I tracked it down to the rtnl_send_check() function
> in lib/libnetlink.c.
> 
> In this function there is the following for loop:
> 
>         for (h = (struct nlmsghdr *)resp; NLMSG_OK(h, status);
>              h = NLMSG_NEXT(h, status)) {
>                 if (h->nlmsg_type == NLMSG_ERROR) {
>                         struct nlmsgerr *err = (struct nlmsgerr*)NLMSG_DATA(h);
>                         if (h->nlmsg_len < NLMSG_LENGTH(sizeof(struct nlmsgerr)))
>                                 fprintf(stderr, "ERROR truncated\n");
>                         else
>                                 errno = -err->error;
> 		}
>                 return -1;
>         }
> 
> I think the "return -1;" should be inside the if statement.
> 
> I attached a patch for this. The first part of the patch is taken from
> one of the late git commits.
> 
> Please note me, if the fix is wrong...
> 
> 
> Regards
>  Sven
> 
> PS: This is a repost, because I neither received a confirmation nor a remark, that
>     the fix is wrong. Moreover the fix didn't make it in the GIT repository yet...
> 

Yes, I posted a similar patch yesterday :)

http://article.gmane.org/gmane.linux.network/142908

Still waiting an ACK from Stephen